ON ERROR GOTO errorend
IF LTRIM$(RTRIM$(COMMAND$)) = "" THEN
  PRINT "Source file name not specified on command line!"
  PRINT
  PRINT " Use this command on the sending machine to encode your file:"
  PRINT "    makedbg yourfile"
  PRINT " This creates a file named: OUTFYL.TXT."
  PRINT " Then, on the PC-3000 (or PC-3100) at a DOS prompt:"
  PRINT "    E:\>mode com1:300,e,7,1"
  PRINT "    E:\>copy com1: outfyl.txt"
  PRINT " Back over on the sending machine, send the OUTFYL.TXT special output file to"
  PRINT " the PC-3000 as a text file using a terminal program of your choice through"
  PRINT " a null modem cable to connect from the sending machine to the serial port of"
  PRINT " of the PC-3000.  Send at 300, 7 data bits. even parity, 1 stop, no handshake."
  PRINT " End of line and inter-character pad timing in the terminal program is a good"
  PRINT " idea.  Handshaking would be better.  Source file length <= 65,535 bytes!"
  PRINT " Then use the DEBUG command to reconstruct the original file"
  PRINT " on the PC-3000:"
  PRINT "    E:\>debug <outfyl.txt"
  PRINT " .EXE and .HEX files are not diectly supported.  This is a limitation from"
  PRINT " using DEBUG for file reconstruction.  Try renaming the source file extension"
  PRINT " to something else before processsing and after reconstruction on the PC-3000."
  PRINT " Example:"
  PRINT "    REN myfile.exe myfile  {Transfer}  REN myfile myfile.exe"
  PRINT " Use at your own risk. Software unsupported & AS-IS.";
  END
END IF
'Make sure that the source file exists.
'An error will trigger on a bad read request.
'Create a trap flag.  If zero then error was
'triggered by nonexistent source.
trapflag% = 0
OPEN COMMAND$ FOR INPUT AS #1
CLOSE
trapflag% = 1
filetype$ = UCASE$(RIGHT$(LTRIM$(RTRIM$(COMMAND$)), 4))
IF (filetype$ = ".EXE") OR (filetype$ = ".HEX") THEN
  PRINT
  PRINT "Error!  .EXE and .HEX files are not supported."
  PRINT
  CLOSE
  END
END IF
'Find length
l& = 0&
OPEN COMMAND$ FOR BINARY AS #1
e% = 0
WHILE e% = 0
  d& = 0&
  dummy$ = INPUT$(1024, #1)
  e% = EOF(1)
  dummylen& = LEN(dummy$)
  l& = l& + dummylen&
WEND
CLOSE
' At this point, the variable l& contains the length
' in bytes of the file specified on the command line.
PRINT "Source file length="; l&; "bytes."
IF (l& > 0&) AND (l& <= 65535) THEN
  OPEN COMMAND$ FOR BINARY AS #1
  OPEN "OUTFYL.TXT" FOR OUTPUT AS #2
  ' In case any spaces or junk came in, start with a <CR> to
  ' get to a clean debug prompt
  PRINT #2, ""
  PRINT #2, "n "; COMMAND$
  PRINT #2, "r cx"
  PRINT #2, HEX$(l&)
  PRINT #2, "a"
  topbyte& = l& - 1&
  PRINT "Generating OUTFYL.TXT output file...";
  FOR z& = 0& TO topbyte&
    IF z& MOD 16& = 0& THEN
      PRINT #2, "db ";
    END IF
    thisbyte$ = INPUT$(1, #1)
    thisasc% = ASC(thisbyte$)
    PRINT #2, LTRIM$(HEX$(thisasc%));
    IF z& MOD 16& = 15& THEN
      PRINT #2, ""
    ELSE
      IF z& < topbyte& THEN
        PRINT #2, ",";
      ELSE
        PRINT #2, ""
      END IF
    END IF
  NEXT z&
  PRINT #2, ""
  PRINT #2, "w"
  PRINT #2, "q"
  'Send a Ctrl-Z line to break the COPY COM connection after transfer
  PRINT #2, CHR$(26)
ELSE
  PRINT
  PRINT "Invalid length source file!"
  PRINT "Must be 1 -> 65535 bytes long."
  CLOSE
  END
END IF
  PRINT "finished."
END

errorend:
CLOSE
PRINT
IF traplfag% = 0 THEN
  PRINT "Soure file specified does not exist!"
ELSE
  PRINT "Error detected.  Go figure."
END IF
PRINT
END

